/*********************************************************************
Ein Kleiner C-Quellcode als ad hock Demoprogramm
zur dynamischen Simulation des Thorium-Zerfalls
nach einem vereinfachten Zerfallsschema.
Kleinster Zeitschritt ist hier eine Sekunde
Die Teilchenzahl wird mit 18 Stellen berechnet (double)
Womit der Zerfall des Mutternuklids th-232 bei 1 Sekunden Zeitschritten
wegen der noch zu geringen rechengenauigkeit leider noch ungenau simuliert wird

Als Demo zur Berechnung der Aktivitaeten
fuer Simulations-Zeiten bis zu 100 Jahren
jedoch in der Regel genau genug.
Dieses Programm simuliert bis zu 20 Jahre
Autor : Chetan Reinhard
email : chetan@t-online.de
WEB   : www.chetan-art.de
Datum : 30.Januar.2011
**********************************************************************/

#include <stdio.h>
#include <dos.h>
#include <math.h>
#include <bios.h>
#include <ctype.h>


FILE *fp1;

/*nuklidvektor
nuklid[n][1] : HWZ
nuklid[n][2] : Zefallskonstante (Zerflle pro Sekunde)
nuklid[n][3] : Teilchenzahl
*/

double nuklid[100][10];
double korrektur1=0.0;

float a,a_ges;

int i,j;

/*Halbwertszeiten in sekunden */
float th232=4.41504E17;
float ra228=181647360.0;
float ac228=22140.0;
float th228=60328368.0;
float ra224=316224.0;
float rn220=55.6;
float po216=0.15;

/*Aktivitaeten */
float a_th232,a_ra228,a_ac228,a_th228,a_ra224,a_rn220,a_po216;

/*Teilchen*/
float t_th232,t_ra228,t_ac228,t_th228,t_ra224,t_rn220,t_po216;
float jahre,tage;

long sekunden,li;

/* zerfallskonstante bezogen auf 1 Sek. */
double z_th232,z_ra228,z_ac228,z_th228,z_ra224,z_rn220,z_po216;
float a_th;
float sekjahr=31536000;

main()
{

system("cls");
printf("Simulation der Thorium-Zerfallsreihe nach einem vereinfachten Zerfallsschema");
tage=0.0;
jahre=0.0;

/* nuklidvektor lschen */
for(i=0;i<=99;i++){
for(j=0;j<=9;j++){
nuklid[i][j]=0.0;}}

/*nuklidvektor mit halbwertszeiten besetzen; */
nuklid[1][1]=th232;
nuklid[2][1]=ra228;
nuklid[3][1]=ac228;
nuklid[4][1]=th228;
nuklid[5][1]=ra224;
nuklid[6][1]=rn220;
nuklid[7][1]=po216;

/*nuklidvektor mit zerfallskonstante besetzen */
/****printf("\nNuklid-Nr.                Zerflle pro sekunde ");****/


for(i=1;i<=7;i++){
nuklid[i][2]=1-exp((double)(-0.69314718/nuklid[i][1]));
/****printf("\n   %d            %20.0fE-20",i,nuklid[i][2]*1E20);****/
                 }

printf("\n\n");
printf("Startzustand besetzen");

printf("\nEingabe Th-232 Aktivitaet [Bq] = ");scanf("%f",&a_th);
nuklid[1][3]=a_th/nuklid[1][2];

printf("\nEingabe Th-228 Aktivitaet [Bq] = ");scanf("%f",&a_th);
nuklid[4][3]=a_th/nuklid[4][2];


/*nuklid[1][3]=a_th232;*/

lbl01:
printf("\nEingabe Simulations-Zeit [Jahre] = ");scanf("%f",&jahre);
if(jahre>20){printf("\nmaximal 20 Jahre ");goto lbl01;}

sekunden=(long)jahre*sekjahr;

/****
printf(" NuklidNr.      Teilchenzahl ");
for(i=1;i<=7;i++)printf("\n%2d    %10.0f",i,nuklid[i][3]);
getchar();getchar();
**/

system("cls");
printf("Simulation der Thorium-Zerfallsreihe nach einem vereinfachten Zerfallsschema");
printf("\nZustandsraummodell diskreter Zeitschritt deltat=1Sek.");
printf("\n1:th232 2:ra228 3:ac228 4:th228 5:ra224 6:rn220 7:po216");
gotoxy(1,5);printf(" jahre       tage  ");
gotoxy(1,10);printf("Nuklid-Nr.   Aktivitt[Bq]                  HWZ[s]");
tage=0.0;


/***********Daten speichern optional
system("del *.txt");
***********************************/

/* hier startet die Simulation */

for(li=0;li<=sekunden;li++){

/* der Zustandsvektor und die Fundamentalmatrix
sind hier in einem nuklidvektor zusammengefasst enthalten
sollte zur besseren bersichtlichkeit getrennt werden werden */


/****** Hier das ganze "Geheimnis" der Simulation...                    *********/
/****** die Multiplikation des Zusandsvektors mit der Fundamentalmatrix *********/
for(j=0;j<=6;j++)nuklid[j+1][3]=nuklid[j+1][3] + nuklid[j][3]*nuklid[j][2] - nuklid[j+1][3]*nuklid[j+1][2];
/********************************************************************************/



/* Anzeige der Ergebnisse jeden tag einmal*/
if(li%86400==0){
tage=tage+1;
jahre=tage/365;
gotoxy(1,6);
printf("%6.2f  %8.0f",jahre,tage);
a_ges=0.0;
gotoxy(1,10);
for(i=1;i<=7;i++){
a=nuklid[i][3]*nuklid[i][2] ;
printf("\n%2d            %9.0f    %25.2f",i,a, nuklid[i][1]);
a_ges=a_ges+a;


/*************** Daten speichern optional
if(i==1){
fp1=fopen("1.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==2){
fp1=fopen("2.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==3){
fp1=fopen("3.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==4){
fp1=fopen("4.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==5){
fp1=fopen("5.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==6){
fp1=fopen("6.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }

if(i==7){
fp1=fopen("7.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a);
fclose(fp1);
        }
*************************/

}
printf("\nAktivitt ges.%9.0f ",a_ges);

/************************Daten speichern optional
fp1=fopen("ges.txt","a");
fprintf(fp1," %6.3f ;  %12.6f \n",jahre,a_ges);
fclose(fp1);
*************************/

               }

                          }


printf("\n**** Simulation beendet *****\n(RETURN bettigen)\n\n");
getchar();



}
